Imports ZedGraph
Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices

Public Class IntTempRangeFig

    'HOB Tools.  A collection of quality check, adjustment, reconstruction, and analysis tools for historical weather observations.
    'Copyright (C) 2013  Dorian J. Burnette

    'This file is part of HOB Tools.

    'HOB Tools is free software: you can redistribute it and/or modify
    'it under the terms of the GNU General Public License as published by
    'the Free Software Foundation, either version 3 of the License, or
    '(at your option) any later version.

    'HOB Tools is distributed in the hope that it will be useful,
    'but WITHOUT ANY WARRANTY; without even the implied warranty of
    'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    'GNU General Public License for more details.

    'You should have received a copy of the GNU General Public License
    'along with HOB Tools.  If not, see <http://www.gnu.org/licenses/>.

    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        'Create Background Gradient
        MyBase.OnPaint(e)
        Dim baseBackground As System.Drawing.Drawing2D.LinearGradientBrush
        baseBackground = New System.Drawing.Drawing2D.LinearGradientBrush(New Point(0, 0), New Point(ClientSize.Width, ClientSize.Height), Color.White, Color.LightSlateGray)
        e.Graphics.FillRectangle(baseBackground, ClientRectangle)
    End Sub

    Private Sub IntTempRangeFig_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        HOBToolsHelp.HelpNamespace = HOBToolsUG
        'Set Plot Month to July (Default)
        Months.SelectedIndex = 6
        'Call Sub to Plot Interhourly Temperature Ranges for July (Default)
        DrawTimeSeries()
    End Sub

    Private Sub DrawTimeSeries()
        Dim MonthName As String
        Dim MonthlyMin As Single
        Dim MonthlyMean As Single
        Dim MonthlyMax As Single
        Dim Year As Integer
        Dim Month As Integer
        Dim Day As Integer
        Dim i As Integer
        i = 0
        Dim DateXAxisData(0) As String
        Dim MonthlyMaxData(0) As Double
        Dim MonthlyMeanData(0) As Double
        Dim MonthlyMinData(0) As Double
        Dim InterhourlyTempData(0) As Double
        'Initialize StreamReader
        Dim InFile As New System.IO.StreamReader(IntTempRange_Output)
        Dim Line As String
        Dim Fields As String()
        'Set StreamReader to Data Start
        Dim Row As Integer
        For Row = 0 To 4
            Line = InFile.ReadLine()
        Next Row
        'Save Month to Store
        Dim StoreMonth As Integer
        If Months.SelectedIndex = 0 Then
            'January
            StoreMonth = 1
            MonthName = "January"
        End If
        If Months.SelectedIndex = 1 Then
            'February
            StoreMonth = 2
            MonthName = "February"
        End If
        If Months.SelectedIndex = 2 Then
            'March
            StoreMonth = 3
            MonthName = "March"
        End If
        If Months.SelectedIndex = 3 Then
            'April
            StoreMonth = 4
            MonthName = "April"
        End If
        If Months.SelectedIndex = 4 Then
            'May
            StoreMonth = 5
            MonthName = "May"
        End If
        If Months.SelectedIndex = 5 Then
            'June
            StoreMonth = 6
            MonthName = "June"
        End If
        If Months.SelectedIndex = 6 Then
            'July
            StoreMonth = 7
            MonthName = "July"
        End If
        If Months.SelectedIndex = 7 Then
            'August
            StoreMonth = 8
            MonthName = "August"
        End If
        If Months.SelectedIndex = 8 Then
            'September
            StoreMonth = 9
            MonthName = "September"
        End If
        If Months.SelectedIndex = 9 Then
            'October
            StoreMonth = 10
            MonthName = "October"
        End If
        If Months.SelectedIndex = 10 Then
            'November
            StoreMonth = 11
            MonthName = "November"
        End If
        If Months.SelectedIndex = 11 Then
            'December
            StoreMonth = 12
            MonthName = "December"
        End If
        'Set Monthly Min and Max
        Do
            Line = InFile.ReadLine
            Fields = Line.Split(ControlChars.Tab)
            If StoreMonth = 1 And Fields(0) = "Jan" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 2 And Fields(0) = "Feb" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 3 And Fields(0) = "Mar" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 4 And Fields(0) = "Apr" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 5 And Fields(0) = "May" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 6 And Fields(0) = "Jun" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 7 And Fields(0) = "Jul" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 8 And Fields(0) = "Aug" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 9 And Fields(0) = "Sep" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 10 And Fields(0) = "Oct" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 11 And Fields(0) = "Nov" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If StoreMonth = 12 And Fields(0) = "Dec" Then
                MonthlyMin = Fields(1)
                MonthlyMean = Fields(3)
                MonthlyMax = Fields(5)
            End If
            If Fields(0) = "Dec" Then
                Exit Do
            End If
        Loop
        'Move Input Line Down Four Lines
        Line = InFile.ReadLine
        Line = InFile.ReadLine
        Line = InFile.ReadLine
        Line = InFile.ReadLine
        'Import Data
        While InFile.Peek <> -1
            Line = InFile.ReadLine
            Fields = Line.Split(ControlChars.Tab)
            Year = Fields(0)
            Month = Fields(1)
            Day = Fields(2)
            If Month = StoreMonth Then
                If i <> 0 Then
                    ReDim Preserve DateXAxisData(i)
                    ReDim Preserve MonthlyMaxData(i)
                    ReDim Preserve MonthlyMinData(i)
                    ReDim Preserve MonthlyMeanData(i)
                    ReDim Preserve InterhourlyTempData(i)
                End If
                'Set X-Axis Value
                DateXAxisData(i) = Year
                'Set Monthly Maximum
                MonthlyMaxData(i) = MonthlyMax
                'Set Monthly Mean
                MonthlyMeanData(i) = MonthlyMean
                'Set Monthly Minimum
                MonthlyMinData(i) = MonthlyMin
                'Set Interhourly Temperature
                If Fields(3) <> -99 Then
                    InterhourlyTempData(i) = Fields(3)
                Else
                    'Denote as Missing
                    InterhourlyTempData(i) = System.Double.MaxValue
                End If
                i = i + 1
            End If
        End While
        InFile.Close()
        'Set Interhouly Temperature Range Chart Properties
        Dim RangePane As GraphPane = RangeChart.GraphPane
        RangePane.CurveList.Clear()
        RangeChart.ZoomOutAll(RangePane)
        RangeChart.MasterPane.Border.IsVisible = False
        RangePane.Border.IsVisible = False
        RangePane.Chart.Border.IsVisible = False
        'Title
        RangePane.Title.Text = IntTempRange_Header & Chr(10) & MonthName
        RangePane.Title.FontSpec.Size = 16
        RangePane.Title.FontSpec.IsBold = True
        'X-Axis
        RangePane.XAxis.Scale.FontSpec.Size = 12
        RangePane.XAxis.Scale.FontSpec.IsBold = True
        RangePane.XAxis.Scale.TextLabels = DateXAxisData
        RangePane.XAxis.Scale.LabelGap = 0.2
        RangePane.XAxis.Type = AxisType.Text
        RangePane.XAxis.Title.Text = "Year"
        RangePane.XAxis.Title.FontSpec.Size = 14
        RangePane.XAxis.Title.FontSpec.IsBold = True
        RangePane.XAxis.MajorTic.PenWidth = 2
        RangePane.XAxis.MajorTic.IsInside = False
        RangePane.XAxis.MajorTic.IsOpposite = False
        RangePane.XAxis.MinorTic.IsAllTics = False
        RangePane.X2Axis.MajorTic.IsAllTics = False
        RangePane.X2Axis.MinorTic.IsAllTics = False
        'Y-Axis
        RangePane.YAxis.Scale.FontSpec.Size = 12
        RangePane.YAxis.Scale.FontSpec.IsBold = True
        RangePane.YAxis.Scale.LabelGap = 0.2
        If IntTempRange_HistoricalDegF = 1 Then
            RangePane.YAxis.Title.Text = "Temperature Range (" & Chr(176) & "F)"
        End If
        If IntTempRange_HistoricalDegC = 1 Then
            RangePane.YAxis.Title.Text = "Temperature Range (" & Chr(176) & "C)"
        End If
        RangePane.YAxis.Title.FontSpec.Size = 14
        RangePane.YAxis.Title.FontSpec.IsBold = True
        RangePane.YAxis.MajorGrid.IsZeroLine = False
        RangePane.YAxis.MajorTic.PenWidth = 2
        RangePane.YAxis.MajorTic.IsInside = False
        RangePane.YAxis.MajorTic.IsOpposite = False
        RangePane.YAxis.MinorTic.IsAllTics = False
        RangePane.Y2Axis.MajorTic.IsAllTics = False
        RangePane.Y2Axis.MinorTic.IsAllTics = False
        'Legend
        RangePane.Legend.Border.IsVisible = False
        RangePane.Legend.Position = LegendPos.BottomCenter
        RangePane.Legend.FontSpec.Size = 10
        RangePane.Legend.FontSpec.IsBold = True
        'Generate Modern Maximum Plot
        Dim ModMaxPlot As LineItem
        ModMaxPlot = RangePane.AddCurve("Modern Maximum", Nothing, MonthlyMaxData, Color.Red, SymbolType.None)
        ModMaxPlot.Line.Width = 1.5
        'Generate Modern Mean Plot
        Dim ModMeanPlot As LineItem
        ModMeanPlot = RangePane.AddCurve("Modern Mean", Nothing, MonthlyMeanData, Color.Green, SymbolType.None)
        ModMeanPlot.Line.Width = 1.5
        'Generate Modern Minimum Plot
        Dim ModMinPlot As LineItem
        ModMinPlot = RangePane.AddCurve("Modern Minimum", Nothing, MonthlyMinData, Color.Blue, SymbolType.None)
        ModMinPlot.Line.Width = 1.5
        'Generate Interhourly Temperature Plot
        Dim HistRangePlot As LineItem
        HistRangePlot = RangePane.AddCurve("Historical Range", Nothing, InterhourlyTempData, Color.Black, SymbolType.None)
        HistRangePlot.Line.SmoothTension = 0
        HistRangePlot.Line.Width = 1.5
        'Calculate Axis Scale Ranges and Refresh Chart
        RangePane.AxisChange()
        RangeChart.Refresh()
        Plot.Text = "Plot"
        Plot.Enabled = True
    End Sub

    Private Sub Plot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Plot.Click
        Plot.Text = "Plotting..."
        Plot.Enabled = False
        DrawTimeSeries()
    End Sub

    Private Sub CopyBitmap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyBitmap.Click
        Clipboard.SetImage(RangeChart.MasterPane.GetImage(2307, 1500, 288, False))
    End Sub

    Private Sub CopyMetafile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyMetafile.Click
        Dim g As Graphics = Me.CreateGraphics()
        Dim hdc As System.IntPtr = g.GetHdc()
        Dim metaFile As New Imaging.Metafile(hdc, Imaging.EmfType.EmfOnly)
        g.ReleaseHdc(hdc)
        g.Dispose()
        Dim gMeta As Graphics = Graphics.FromImage(metaFile)
        RangeChart.MasterPane.Draw(gMeta)
        gMeta.Dispose()
        ClipboardMetafileHelper.PutEnhMetafileOnClipboard(Me.Handle, metaFile)
    End Sub

    Private Sub SaveChart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveChart.Click
        Dim SaveIntTempRangePlot As New SaveFileDialog
        Dim OutputImage As String
        SaveIntTempRangePlot.Title = "Save Interhourly Temperature Range Plot"
        SaveIntTempRangePlot.Filter = "Bitmap (*.bmp)|*.bmp|GIF (*.gif)|*.gif|JPEG (*.jpg)|*.jpg|PNG (*.png)|*.png|TIFF (*.tif)|*.tif"
        If SaveIntTempRangePlot.ShowDialog = Windows.Forms.DialogResult.OK Then
            OutputImage = SaveIntTempRangePlot.FileName
            If SaveIntTempRangePlot.FileName.EndsWith("bmp") Then
                RangeChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Bmp)
            End If
            If SaveIntTempRangePlot.FileName.EndsWith("gif") Then
                RangeChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Gif)
            End If
            If SaveIntTempRangePlot.FileName.EndsWith("jpg") Then
                RangeChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Jpeg)
            End If
            If SaveIntTempRangePlot.FileName.EndsWith("png") Then
                RangeChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Png)
            End If
            If SaveIntTempRangePlot.FileName.EndsWith("tif") Then
                RangeChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Tiff)
            End If
        End If
    End Sub

    Private Sub PrintChart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintChart.Click
        RangeChart.DoPrint()
    End Sub

    Private Sub RangeChart_ContextMenuBuilder(ByVal sender As ZedGraph.ZedGraphControl, ByVal menuStrip As System.Windows.Forms.ContextMenuStrip, ByVal mousePt As System.Drawing.Point, ByVal objState As ZedGraph.ZedGraphControl.ContextMenuObjectState) Handles RangeChart.ContextMenuBuilder
        'Remove Specific Functions from Interhourly Temperature Range Chart Context Menu for Use Elsewhere
        Dim Item As ToolStripMenuItem
        Dim CopyItem As ToolStripMenuItem
        Dim PageSetupItem As ToolStripMenuItem
        Dim PrintItem As ToolStripMenuItem
        Dim SaveAsItem As ToolStripMenuItem
        Dim SetScaleItem As ToolStripMenuItem
        For Each Item In menuStrip.Items
            If Item.Tag = "copy" Then
                CopyItem = Item
            End If
            If Item.Tag = "page_setup" Then
                PageSetupItem = Item
            End If
            If Item.Tag = "print" Then
                PrintItem = Item
            End If
            If Item.Tag = "save_as" Then
                SaveAsItem = Item
            End If
            If Item.Tag = "set_default" Then
                SetScaleItem = Item
            End If
        Next Item
        menuStrip.Items.Remove(CopyItem)
        menuStrip.Items.Remove(PageSetupItem)
        menuStrip.Items.Remove(PrintItem)
        menuStrip.Items.Remove(SaveAsItem)
        menuStrip.Items.Remove(SetScaleItem)
    End Sub

    Private Sub IntTempRangeFig_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        'Allow Tool to be Open Again
        IntTempRangeFigDisp = 0
    End Sub
End Class