Imports ZedGraph
Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices
Public Class ScreenPrecipFig

    'HOB Tools.  A collection of quality check, adjustment, reconstruction, and analysis tools for historical weather observations.
    'Copyright (C) 2013  Dorian J. Burnette

    'This file is part of HOB Tools.

    'HOB Tools is free software: you can redistribute it and/or modify
    'it under the terms of the GNU General Public License as published by
    'the Free Software Foundation, either version 3 of the License, or
    '(at your option) any later version.

    'HOB Tools is distributed in the hope that it will be useful,
    'but WITHOUT ANY WARRANTY; without even the implied warranty of
    'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    'GNU General Public License for more details.

    'You should have received a copy of the GNU General Public License
    'along with HOB Tools.  If not, see <http://www.gnu.org/licenses/>.

    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        'Create Background Gradient
        MyBase.OnPaint(e)
        Dim baseBackground As System.Drawing.Drawing2D.LinearGradientBrush
        baseBackground = New System.Drawing.Drawing2D.LinearGradientBrush(New Point(0, 0), New Point(ClientSize.Width, ClientSize.Height), Color.White, Color.LightSlateGray)
        e.Graphics.FillRectangle(baseBackground, ClientRectangle)
    End Sub

    Private Sub ScreenPrecipFig_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        HOBToolsHelp.HelpNamespace = HOBToolsUG
        'Set Plot to All Data (Default)
        DisplayedPlot.SelectedIndex = 0
        'Call Sub to Draw the Daily Precipitation Frequency Histogram
        DrawHistogram()
    End Sub

    Private Sub DrawHistogram()
        Dim StartDate As Date
        Dim EndDate As Date
        Dim TimeFilter As String
        Dim CompleteData(200) As Double
        Dim JanData(200) As Double
        Dim FebData(200) As Double
        Dim MarData(200) As Double
        Dim AprData(200) As Double
        Dim MayData(200) As Double
        Dim JunData(200) As Double
        Dim JulData(200) As Double
        Dim AugData(200) As Double
        Dim SepData(200) As Double
        Dim OctData(200) As Double
        Dim NovData(200) As Double
        Dim DecData(200) As Double
        Dim PrecipList As New PointPairList()
        Dim x As Double
        Dim y As Double
        x = 1
        'Initialize StreamReader
        Dim InFile As New System.IO.StreamReader(ScreenPrecip_Output)
        Dim Line As String
        Dim Fields As String()
        'Set StreamReader to Data Start
        Dim Row As Integer
        For Row = 0 To 2
            Line = InFile.ReadLine()
        Next Row
        'Save Date Information for Chart Title
        StartDate = DateValue(ScreenPrecip_StartMonth & "/" & ScreenPrecip_StartDay & "/" & ScreenPrecip_StartYear)
        EndDate = DateValue(ScreenPrecip_EndMonth & "/" & ScreenPrecip_EndDay & "/" & ScreenPrecip_EndYear)
        'Import Data
        While InFile.Peek <> -1
            Line = InFile.ReadLine
            Fields = Line.Split(ControlChars.Tab)
            Select Case Fields(0)
                Case Is = "All"
                    'All Data
                    CompleteData(Fields(1)) = Fields(2)
                Case Is = "Jan"
                    'January
                    JanData(Fields(1)) = Fields(2)
                Case Is = "Feb"
                    'February
                    FebData(Fields(1)) = Fields(2)
                Case Is = "Mar"
                    'March
                    MarData(Fields(1)) = Fields(2)
                Case Is = "Apr"
                    'April
                    AprData(Fields(1)) = Fields(2)
                Case Is = "May"
                    'May
                    MayData(Fields(1)) = Fields(2)
                Case Is = "Jun"
                    'June
                    JunData(Fields(1)) = Fields(2)
                Case Is = "Jul"
                    'July
                    JulData(Fields(1)) = Fields(2)
                Case Is = "Aug"
                    'August
                    AugData(Fields(1)) = Fields(2)
                Case Is = "Sep"
                    'September
                    SepData(Fields(1)) = Fields(2)
                Case Is = "Oct"
                    'October
                    OctData(Fields(1)) = Fields(2)
                Case Is = "Nov"
                    'November
                    NovData(Fields(1)) = Fields(2)
                Case Is = "Dec"
                    'December
                    DecData(Fields(1)) = Fields(2)
            End Select
            y = Fields(1)
        End While
        InFile.Close()
        For x = 0 To 200
            Select Case DisplayedPlot.SelectedIndex
                Case 0
                    'y = All Data
                    y = CompleteData(x)
                Case 1
                    'y = Winter Data
                    y = JanData(x) + FebData(x) + DecData(x)
                    TimeFilter = "Winter"
                Case 2
                    'y = Spring Data
                    y = MarData(x) + AprData(x) + MayData(x)
                    TimeFilter = "Spring"
                Case 3
                    'y = Summer Data
                    y = JunData(x) + JulData(x) + AugData(x)
                    TimeFilter = "Summer"
                Case 4
                    'y = Fall Data
                    y = SepData(x) + OctData(x) + NovData(x)
                    TimeFilter = "Fall"
                Case 5
                    'y = January Data
                    y = JanData(x)
                    TimeFilter = "January"
                Case 6
                    'y = February Data
                    y = FebData(x)
                    TimeFilter = "February"
                Case 7
                    'y = March Data
                    y = MarData(x)
                    TimeFilter = "March"
                Case 8
                    'y = April Data
                    y = AprData(x)
                    TimeFilter = "April"
                Case 9
                    'y = May Data
                    y = MayData(x)
                    TimeFilter = "May"
                Case 10
                    'y = June Data
                    y = JunData(x)
                    TimeFilter = "June"
                Case 11
                    'y = July Data
                    y = JulData(x)
                    TimeFilter = "July"
                Case 12
                    'y = August Data
                    y = AugData(x)
                    TimeFilter = "August"
                Case 13
                    'y = September Data
                    y = SepData(x)
                    TimeFilter = "September"
                Case 14
                    'y = October Data
                    y = OctData(x)
                    TimeFilter = "October"
                Case 15
                    'y = November Data
                    y = NovData(x)
                    TimeFilter = "November"
                Case 16
                    'y = December Data
                    y = DecData(x)
                    TimeFilter = "December"
                Case 17
                    'y = March-August Data
                    y = MarData(x) + AprData(x) + MayData(x) + JunData(x) + JulData(x) + AugData(x)
                    TimeFilter = "March - August"
                Case 18
                    'y = April-August Data
                    y = AprData(x) + MayData(x) + JunData(x) + JulData(x) + AugData(x)
                    TimeFilter = "April - August"
                Case 19
                    'y = May-August Data
                    y = MayData(x) + JunData(x) + JulData(x) + AugData(x)
                    TimeFilter = "May - August"
            End Select
            If x = 0 Then
                PrecipList.Add(0, 0)
            Else
                PrecipList.Add(x, y)
            End If
        Next x
        'Draw Bar Chart
        Dim PrecipPane As GraphPane = PrecipChart.GraphPane
        PrecipPane.CurveList.Clear()
        PrecipChart.ZoomOutAll(PrecipPane)
        PrecipChart.MasterPane.Border.IsVisible = False
        PrecipPane.Border.IsVisible = False
        PrecipPane.Chart.Border.IsVisible = False
        'Set Bar Chart Properties
        'Set Title
        If DisplayedPlot.SelectedIndex = 0 Then
            PrecipPane.Title.Text = ScreenPrecip_Header & ControlChars.CrLf & StartDate & " - " & EndDate
        Else
            PrecipPane.Title.Text = ScreenPrecip_Header & ControlChars.CrLf & TimeFilter & " " & StartDate & " - " & EndDate
        End If
        PrecipPane.Title.FontSpec.Size = 16
        PrecipPane.Title.FontSpec.IsBold = True
        'Set X-Axis
        PrecipPane.XAxis.Scale.Min = 0
        PrecipPane.XAxis.Scale.Max = 200
        PrecipPane.XAxis.Scale.FontSpec.Size = 12
        PrecipPane.XAxis.Scale.FontSpec.IsBold = True
        PrecipPane.XAxis.Scale.LabelGap = 0.2
        PrecipPane.XAxis.Title.Text = "Precipitation Amounts (Hundredths of an Inch)"
        PrecipPane.XAxis.Title.FontSpec.Size = 14
        PrecipPane.XAxis.Title.FontSpec.IsBold = True
        PrecipPane.XAxis.MajorTic.PenWidth = 2
        PrecipPane.XAxis.MajorTic.IsInside = False
        PrecipPane.XAxis.MajorTic.IsOpposite = False
        PrecipPane.XAxis.MajorTic.Size = 10
        PrecipPane.XAxis.MinorTic.IsInside = False
        PrecipPane.XAxis.MinorTic.IsOpposite = False
        PrecipPane.XAxis.MinorTic.Size = 5
        PrecipPane.X2Axis.MajorTic.IsAllTics = False
        PrecipPane.X2Axis.MinorTic.IsAllTics = False
        'Set Y-Axis
        PrecipPane.YAxis.Scale.FontSpec.Size = 12
        PrecipPane.YAxis.Scale.FontSpec.IsBold = True
        PrecipPane.YAxis.Scale.LabelGap = 0.2
        PrecipPane.YAxis.Title.Text = "Frequency"
        PrecipPane.YAxis.Title.FontSpec.Size = 14
        PrecipPane.YAxis.Title.FontSpec.IsBold = True
        PrecipPane.YAxis.MajorGrid.IsZeroLine = False
        PrecipPane.YAxis.MajorTic.PenWidth = 2
        PrecipPane.YAxis.MajorTic.IsInside = False
        PrecipPane.YAxis.MajorTic.IsOpposite = False
        PrecipPane.YAxis.MajorTic.Size = 10
        PrecipPane.YAxis.MinorTic.IsAllTics = False
        PrecipPane.Y2Axis.MajorTic.IsAllTics = False
        PrecipPane.Y2Axis.MinorTic.IsAllTics = False
        'Turn off Legend
        PrecipPane.Legend.IsVisible = False
        'Generate Precipitation Bars
        PrecipPane.AddBar("Precipiation Days", PrecipList, Color.Red)
        'Calculate Axis Scale Ranges and Refresh Chart
        PrecipPane.AxisChange()
        PrecipChart.Refresh()
        Plot.Text = "Plot"
        Plot.Enabled = True
    End Sub

    Private Sub Plot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Plot.Click
        'ReDraw Precipitation Frequency Histogram
        Plot.Text = "Plotting..."
        Plot.Enabled = False
        DrawHistogram()
    End Sub

    Private Sub CopyBitmap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyBitmap.Click
        Clipboard.SetImage(PrecipChart.MasterPane.GetImage(2307, 1500, 288, False))
    End Sub

    Private Sub CopyMetafile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyMetafile.Click
        Dim g As Graphics = Me.CreateGraphics()
        Dim hdc As System.IntPtr = g.GetHdc()
        Dim metaFile As New Imaging.Metafile(hdc, Imaging.EmfType.EmfOnly)
        g.ReleaseHdc(hdc)
        g.Dispose()
        Dim gMeta As Graphics = Graphics.FromImage(metaFile)
        PrecipChart.MasterPane.Draw(gMeta)
        gMeta.Dispose()
        ClipboardMetafileHelper.PutEnhMetafileOnClipboard(Me.Handle, metaFile)
    End Sub

    Private Sub SaveChart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveChart.Click
        Dim SaveResidualPlot As New SaveFileDialog
        Dim OutputImage As String
        SaveResidualPlot.Title = "Save Precipitation Frequency Histogram"
        SaveResidualPlot.Filter = "Bitmap (*.bmp)|*.bmp|GIF (*.gif)|*.gif|JPEG (*.jpg)|*.jpg|PNG (*.png)|*.png|TIFF (*.tif)|*.tif"
        If SaveResidualPlot.ShowDialog = Windows.Forms.DialogResult.OK Then
            OutputImage = SaveResidualPlot.FileName
            If SaveResidualPlot.FileName.EndsWith("bmp") Then
                PrecipChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Bmp)
            End If
            If SaveResidualPlot.FileName.EndsWith("gif") Then
                PrecipChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Gif)
            End If
            If SaveResidualPlot.FileName.EndsWith("jpg") Then
                PrecipChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Jpeg)
            End If
            If SaveResidualPlot.FileName.EndsWith("png") Then
                PrecipChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Png)
            End If
            If SaveResidualPlot.FileName.EndsWith("tif") Then
                PrecipChart.MasterPane.GetImage(2307, 1500, 288, False).Save(OutputImage, System.Drawing.Imaging.ImageFormat.Tiff)
            End If
        End If
    End Sub

    Private Sub PrintChart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintChart.Click
        PrecipChart.DoPrint()
    End Sub

    Private Sub PrecipChart_ContextMenuBuilder(ByVal sender As ZedGraph.ZedGraphControl, ByVal menuStrip As System.Windows.Forms.ContextMenuStrip, ByVal mousePt As System.Drawing.Point, ByVal objState As ZedGraph.ZedGraphControl.ContextMenuObjectState) Handles PrecipChart.ContextMenuBuilder
        'Remove Specific Functions from Precip Chart Context Menu for Use Elsewhere
        Dim Item As ToolStripMenuItem
        Dim CopyItem As ToolStripMenuItem
        Dim PageSetupItem As ToolStripMenuItem
        Dim PrintItem As ToolStripMenuItem
        Dim SaveAsItem As ToolStripMenuItem
        Dim SetScaleItem As ToolStripMenuItem
        For Each Item In menuStrip.Items
            If Item.Tag = "copy" Then
                CopyItem = Item
            End If
            If Item.Tag = "page_setup" Then
                PageSetupItem = Item
            End If
            If Item.Tag = "print" Then
                PrintItem = Item
            End If
            If Item.Tag = "save_as" Then
                SaveAsItem = Item
            End If
            If Item.Tag = "set_default" Then
                SetScaleItem = Item
            End If
        Next Item
        menuStrip.Items.Remove(CopyItem)
        menuStrip.Items.Remove(PageSetupItem)
        menuStrip.Items.Remove(PrintItem)
        menuStrip.Items.Remove(SaveAsItem)
        menuStrip.Items.Remove(SetScaleItem)
    End Sub

    Private Sub ScreenPrecipFig_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        'Allow Tool to be Open Again
        ScreenPrecipFigDisp = 0
    End Sub
End Class